/*
 * Description of state machine controlling VMEbus master accesses.
 */

input	xdel, bgin, want_1, acc_1, rel_1, rel_2, resp_2, access, xdel2;
input	reset;
output	x, bgout, tbbsy, drivevb, tas;

asynchronous state_machine => <outputs>
{
	all_states: reset => idle;

	idle: <00000>
		~xdel & bgin => s1;

	s1: <x>
		~bgin => idle
		else
		xdel & want_1 => go,
		xdel & ~want_1 => pass_grant;

	pass_grant: <bgout, x>
		~bgin => idle
		else
		1 => s2;

	s2: <bgout>
		~bgin => idle;

	go: <tbbsy, drivevb>
		~xdel & (acc_1 | rel_1) => s5;

	s5: <x, tbbsy, drivevb>
		xdel & acc_1 & (resp_2 | rel_2) => s8
		else xdel & acc_1 => s7
		else xdel & rel_1 => release
		else xdel => go;

	release: <tbbsy>
		~xdel2 => idle;

	s7: <x, tas, tbbsy, drivevb>
		xdel & (resp_2 | rel_2) => s8;

	s8: <tas, tbbsy, drivevb>
		~xdel & rel_2 => rel_in_cycle
		else ~xdel & resp_2 => go
		else ~xdel => s7;

	rel_in_cycle: <tas, drivevb>
		xdel & ~access => s10;

	s10: <tas>
		~xdel2 => idle;
};
